package cn.hhj.rabbitmq.producer;

import cn.hhj.rabbitmq.entity.Merchant;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.springframework.amqp.core.AmqpTemplate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.PropertySource;
import org.springframework.stereotype.Component;

@Component
@PropertySource("classpath:rabbitmq.properties")
public class RabbitSender {

    @Value("${cn.hhj.rabbitmq.directexchange}")
    private String directExchange;

    @Value("${cn.hhj.rabbitmq.topicexchange}")
    private String topicExchange;

    @Value("${cn.hhj.rabbitmq.fanoutexchange}")
    private String fanoutExchange;

    @Value("${cn.hhj.rabbitmq.directroutingkey}")
    private String directRoutingKey;

    @Value("${cn.hhj.rabbitmq.topicroutingkey1}")
    private String topicRoutingKey1;

    @Value("${cn.hhj.rabbitmq.topicroutingkey2}")
    private String topicRoutingKey2;

    // 自定义的模板，所有的消息都会转换成JSON发送
    @Autowired
    AmqpTemplate amqpTemplate;

    public void send() throws JsonProcessingException {
        Merchant merchant =  new Merchant(1001,"a direct msg : 中原镖局","汉中省解放路266号");
        amqpTemplate.convertAndSend(directExchange,directRoutingKey, merchant);

        amqpTemplate.convertAndSend(topicExchange,topicRoutingKey1, "a topic msg : shanghai.gupao.teacher");
        amqpTemplate.convertAndSend(topicExchange,topicRoutingKey2, "a topic msg : changsha.gupao.student");

        // 发送JSON字符串
        ObjectMapper mapper = new ObjectMapper();
        String json = mapper.writeValueAsString(merchant);
        System.out.println(json);
        amqpTemplate.convertAndSend(fanoutExchange,"", json);
    }
}
